//+------------------------------------------------------------------+
//| Custom MACD.mq4 |
//| Copyright  2004, MetaQuotes Software Corp. |
//| http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net/"
#property copyright "Copyright  2006, Akuma99."
#property link "http://www.beginnertrader.com/"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 LawnGreen
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 LawnGreen
#property indicator_color5 LightSkyBlue
#property indicator_color6 Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3 
#property indicator_width4 3 
#property indicator_width5 3 
#property indicator_width6 3 

extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;

double ind_buffer1[];
double ind_buffer2[];
double ind_buffer1b[];
double ind_buffer2b[];
double ind_buffer3[];
double ind_buffer4[];

double b[999999];

int init() {

SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
SetIndexStyle(4,DRAW_LINE,EMPTY);
SetIndexStyle(5,DRAW_LINE,EMPTY);
SetIndexBuffer(0,ind_buffer1);
SetIndexBuffer(1,ind_buffer2);
SetIndexBuffer(2,ind_buffer1b);
SetIndexBuffer(3,ind_buffer2b);
SetIndexBuffer(4,ind_buffer3);
SetIndexBuffer(5,ind_buffer4);

IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1 );

return(0);

}

int start(){

int limit;
int counted_bars=IndicatorCounted();

if(counted_bars<0) return(-1);

if(counted_bars>0) counted_bars--;
limit=Bars-counted_bars;

for(int i=limit; i>=0; i--) {

b[i] = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
ind_buffer1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);

clearBuffers(i);

if (b[i] < 0 ) {
if (b[i] > b[i+1]) {
ind_buffer1[i] = b[i];
ind_buffer1b[i] = 0;
} else if (b[i] < b[i+1]) {
ind_buffer1b[i] = b[i];
ind_buffer1[i] = 0;
}
} else if (b[i] > 0) {
if (b[i] < b[i+1]) {
ind_buffer2[i] = b[i];
ind_buffer2b[i] = 0;
} else if (b[i] > b[i+1]) {
ind_buffer2b[i] = b[i];
ind_buffer2[i] = 0;
}
}

ind_buffer3[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);

}

for(i=0; i<limit; i++) {
ind_buffer4[i]=iMAOnArray(ind_buffer3,Bars,SignalSMA,0,MODE_SMA, i);
}

return(0);

}

void clearBuffers (int i) {

ind_buffer1[i] = NULL;
ind_buffer1b[i] = NULL;
ind_buffer2[i] = NULL;
ind_buffer2b[i] = NULL;

}
//+------------------------------------------------------------------+